package com.company.Commander;

import com.company.ImageLoader;
import com.company.ImageMaker;
import com.company.QR.QRCode;

import javax.imageio.IIOImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.plugins.jpeg.JPEGImageWriteParam;
import javax.imageio.stream.FileImageOutputStream;
import javax.swing.*;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class CommanderApp {

    private QRCode client;

    private JFrame frame;
    private JTextField txtText;
    private JTextField imgSource;
    private JTextField imgDest;
    private JButton btnColorLight;
    private JButton btnColorLight2;
    private JButton btnColorDark;
    private JButton btnColorDark2;

    private Boolean firstDarkColor = null;
    private Boolean oppositeColorSetup = false;
    private Boolean destinationChanged = false;

    private String correctionLevel = "L";

    private Color defaultColorDark = new Color(111, 111, 100);
    private Color defaultColorLight = new Color(255, 255, 255);
    private Color defaultColorDark2 = new Color(172, 19, 13);
    private Color defaultColorLight2 = new Color(255, 167, 172);

    public CommanderApp(QRCode qr) {
        frame = new JFrame();
        frame.setTitle("QR logo");
        init();
        frame.setVisible(true);

        client = qr;
    }

    private void init() {
        initialize();
        frame.pack();
    }

    private void initialize() {
        frame = new JFrame();
        frame.setTitle("QR Logo Generator");
        frame.setBounds(100, 100, 800, 250);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setResizable(false);

        JPanel panel = new JPanel();
        panel.setBorder(new TitledBorder(null, "Text", TitledBorder.LEADING, TitledBorder.TOP, null, null));

        JPanel panel_1 = new JPanel();
        panel_1.setBorder(new TitledBorder(null, "Barva", TitledBorder.LEADING, TitledBorder.TOP, null, null));

        JPanel panel_2 = new JPanel();
        panel_2.setBorder(new TitledBorder(null, "Obrázek", TitledBorder.LEADING, TitledBorder.TOP, null, null));

        JButton btnGenerovat = new JButton("Generovat");
        btnGenerovat.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                btnCallGenerate();
            }
        });
        GroupLayout groupLayout = new GroupLayout(frame.getContentPane());
        groupLayout.setHorizontalGroup(
                groupLayout.createParallelGroup(Alignment.LEADING)
                        .addGroup(groupLayout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
                                        .addGroup(groupLayout.createSequentialGroup()
                                                .addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
                                                        .addComponent(panel, GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE)
                                                        .addComponent(panel_2, GroupLayout.PREFERRED_SIZE, 286, Short.MAX_VALUE))
                                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                                .addComponent(panel_1, GroupLayout.DEFAULT_SIZE, 261, Short.MAX_VALUE))
                                        .addComponent(btnGenerovat, Alignment.TRAILING, GroupLayout.PREFERRED_SIZE, 160, GroupLayout.PREFERRED_SIZE))
                                .addContainerGap())
        );
        groupLayout.setVerticalGroup(
                groupLayout.createParallelGroup(Alignment.LEADING)
                        .addGroup(groupLayout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(groupLayout.createParallelGroup(Alignment.LEADING, false)
                                        .addGroup(groupLayout.createSequentialGroup()
                                                .addComponent(panel, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                                .addComponent(panel_2, GroupLayout.PREFERRED_SIZE, 108, GroupLayout.PREFERRED_SIZE))
                                        .addComponent(panel_1, 0, 0, Short.MAX_VALUE))
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addComponent(btnGenerovat, GroupLayout.PREFERRED_SIZE, 65, GroupLayout.PREFERRED_SIZE)
                                .addGap(15))
        );

        JLabel lblNewLabel = new JLabel("Tmavá barva:");
        JLabel lblLight = new JLabel("Světlá barva:");

        btnColorDark = new JButton("Tmavá barva");
        btnColorDark.setToolTipText("Nastavení základní světlé barvy.");
        btnColorDark.setBackground(defaultColorDark);
        btnColorDark.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                btnCallColor(1);
            }
        });

        btnColorLight = new JButton("Světlá barva");
        btnColorLight.setToolTipText("Nastavení základní světlé barvy.");
        btnColorLight.setBackground(defaultColorLight);
        btnColorLight.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                btnCallColor(2);
            }
        });

        JLabel lblDarkModul = new JLabel("Tmavý modul:");
        JLabel lblLightModul = new JLabel("Světlý modul:");

        btnColorDark2 = new JButton("Tmavá barva loga");
        btnColorDark2.setToolTipText("Nastavení barvy pro tmavou barvu obrázku.");
        btnColorDark2.setBackground(defaultColorDark2);
        btnColorDark2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                btnCallColor(3);
            }
        });

        btnColorLight2 = new JButton("Světlá barva loga");
        btnColorLight2.setToolTipText("Nastavení barvy pro světlou barvu obrázku.");
        btnColorLight2.setBackground(defaultColorLight2);
        btnColorLight2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                btnCallColor(4);
            }
        });
        GroupLayout gl_panel_1 = new GroupLayout(panel_1);
        gl_panel_1.setHorizontalGroup(
                gl_panel_1.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_panel_1.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(gl_panel_1.createParallelGroup(Alignment.LEADING)
                                        .addComponent(lblNewLabel)
                                        .addComponent(lblLight)
                                        .addComponent(lblDarkModul)
                                        .addComponent(lblLightModul))
                                .addGap(53)
                                .addGroup(gl_panel_1.createParallelGroup(Alignment.TRAILING)
                                        .addComponent(btnColorDark2, GroupLayout.DEFAULT_SIZE, 122, Short.MAX_VALUE)
                                        .addComponent(btnColorLight, GroupLayout.DEFAULT_SIZE, 122, Short.MAX_VALUE)
                                        .addComponent(btnColorDark, Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 122, Short.MAX_VALUE)
                                        .addComponent(btnColorLight2, GroupLayout.DEFAULT_SIZE, 122, Short.MAX_VALUE))
                                .addContainerGap())
        );
        gl_panel_1.setVerticalGroup(
                gl_panel_1.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_panel_1.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(gl_panel_1.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(btnColorDark)
                                        .addComponent(lblNewLabel))
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addGroup(gl_panel_1.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(btnColorLight)
                                        .addComponent(lblLight))
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addGroup(gl_panel_1.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(btnColorDark2)
                                        .addComponent(lblDarkModul))
                                .addGap(6)
                                .addGroup(gl_panel_1.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(btnColorLight2)
                                        .addComponent(lblLightModul))
                                .addContainerGap(68, Short.MAX_VALUE))
        );
        panel_1.setLayout(gl_panel_1);

        JLabel lblObrazek = new JLabel("Obrázek:");

        imgSource = new JTextField();
        imgSource.setToolTipText("Zdrojová cesta vstupního loga.");
        imgSource.setColumns(10);

        JLabel lblUlozitDo = new JLabel("Uložit do:");

        imgDest = new JTextField();
        imgDest.setToolTipText("Cílová cesta generovaného obrázku.");
        imgDest.setColumns(10);

        JButton btnChooser2 = new JButton("...");
        btnChooser2.setToolTipText("Vyvolání dialogu pro načtení zdrojového loga.");
        btnChooser2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                btnCallFileIn();
            }
        });

        JButton btnChooser3 = new JButton("...");
        btnChooser3.setToolTipText("Vyvolání dialogu pro uložení cílové cesty.");
        btnChooser3.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                btnCallFileOut();
            }
        });
        GroupLayout gl_panel_2 = new GroupLayout(panel_2);
        gl_panel_2.setHorizontalGroup(
                gl_panel_2.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_panel_2.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(gl_panel_2.createParallelGroup(Alignment.TRAILING)
                                        .addComponent(lblUlozitDo)
                                        .addComponent(lblObrazek))
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addGroup(gl_panel_2.createParallelGroup(Alignment.LEADING, false)
                                        .addComponent(imgDest)
                                        .addComponent(imgSource, GroupLayout.DEFAULT_SIZE, 174, Short.MAX_VALUE))
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addGroup(gl_panel_2.createParallelGroup(Alignment.LEADING)
                                        .addGroup(gl_panel_2.createSequentialGroup()
                                                .addComponent(btnChooser2, GroupLayout.PREFERRED_SIZE, 18, GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(ComponentPlacement.RELATED)
                                                .addGap(0)
                                        )
                                        .addGroup(gl_panel_2.createSequentialGroup()
                                                .addComponent(btnChooser3, GroupLayout.PREFERRED_SIZE, 18, GroupLayout.PREFERRED_SIZE)
//                                                .addContainerGap()
                                        )))
        );
        gl_panel_2.setVerticalGroup(
                gl_panel_2.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_panel_2.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(gl_panel_2.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(lblObrazek)
                                        .addComponent(imgSource, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                        .addComponent(btnChooser2))
                                .addGap(11)
                                .addGroup(gl_panel_2.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(lblUlozitDo)
                                        .addComponent(imgDest, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                        .addComponent(btnChooser3))
//                                .addContainerGap(52, Short.MAX_VALUE)
                        )
        );
        panel_2.setLayout(gl_panel_2);

        JLabel lblText = new JLabel("Text:");

        JLabel lblKorekciLevel = new JLabel("Korekční úroveň:");

        txtText = new JTextField();
        txtText.setToolTipText("Pole pro zprávu, která má být zakódována.");
        txtText.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            }
        });
        txtText.setColumns(10);

        final JComboBox comboLvl = new JComboBox();
        comboLvl.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                correctionLevel = comboLvl.getSelectedItem().toString();
            }
        });
        comboLvl.addItem("L");
        comboLvl.addItem("M");
        comboLvl.addItem("Q");
        comboLvl.addItem("H");
        comboLvl.setToolTipText("Nastavení korekční úrovně. Toto nastavení ovlivňuje hustotu a velikost QR kódu.");
        GroupLayout gl_panel = new GroupLayout(panel);
        gl_panel.setHorizontalGroup(
                gl_panel.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_panel.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
                                        .addComponent(lblKorekciLevel)
                                        .addComponent(lblText))
                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                .addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
                                        .addComponent(txtText, GroupLayout.DEFAULT_SIZE, 177, Short.MAX_VALUE)
                                        .addComponent(comboLvl, 0, 189, Short.MAX_VALUE))
                                .addContainerGap())
        );
        gl_panel.setVerticalGroup(
                gl_panel.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_panel.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(lblText)
                                        .addComponent(txtText, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(ComponentPlacement.UNRELATED)
                                .addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(lblKorekciLevel)
                                        .addComponent(comboLvl, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                                .addContainerGap(13, Short.MAX_VALUE))
        );
        panel.setLayout(gl_panel);
        frame.getContentPane().setLayout(groupLayout);

        txtText.setText("www.pef.czu.cz");
        imgSource.setText("C:\\Users\\Honza\\Dropbox\\QR logo generator\\logo\\pef.jpg");
        imgDest.setText("C:\\Users\\Honza\\Dropbox\\QR logo generator\\logo\\blue\\qr.jpg");
    }

    private void btnCallGenerate() {
        String message = txtText.getText();
        client.encode(message, correctionLevel);
        processLogo();

        //String hex = String.format("06X", (0xFFFFFF - color));
    }

    private void processLogo() {
        File imgPath = new File(imgSource.getText());
        BufferedImage bufferedImage = null;
        try {
            bufferedImage = ImageIO.read(imgPath);
        } catch (IOException e) {
            e.printStackTrace();
            return;
        }

        int density = 10;
        int size = 7;
        int width = client.getMatrix().getMatrix().length;

        ImageLoader imageLoader = new ImageLoader(bufferedImage, width, width, density);
        int[][] logo = imageLoader.getPixels();

        File output = new File(imgDest.getText());
        ImageMaker imgMaker = new ImageMaker();
        imgMaker.setupColors(btnColorDark.getBackground(),
                            btnColorLight.getBackground(),
                            btnColorDark2.getBackground(),
                            btnColorLight2.getBackground());
        BufferedImage img = imgMaker.mergeQRLogo(client.getMatrix().getMatrix(), logo, density, size);
        try {
            JPEGImageWriteParam jpegParams = new JPEGImageWriteParam(null);
            jpegParams.setCompressionMode(ImageWriteParam.MODE_EXPLICIT);
            jpegParams.setCompressionQuality(1f);

            ImageWriter writer = ImageIO.getImageWritersByFormatName("jpg").next();
            writer.setOutput(new FileImageOutputStream(output));
            writer.write(null, new IIOImage(img, null, null), jpegParams);

            Desktop desktop = Desktop.getDesktop();
            desktop.open(output);
        } catch (IOException e) {
        }
    }

    private void btnCallColor(int i) {
        Color actualColor = getActualColor(i);
        Color newColor = JColorChooser.showDialog(
            frame,
            "Choose module Color",
            actualColor);

        if (newColor != null) {
            switch (i) {
                case 1:
                    btnColorDark.setBackground(newColor);
                    break;
                case 2:
                    btnColorLight.setBackground(newColor);
                    break;
                case 3:
                    btnColorDark2.setBackground(newColor);
//                    btnColorLight2.setBackground(countBrightOppositeColor(newColor));
                    /*if (firstDarkColor == null || (firstDarkColor && !oppositeColorSetup)) {
                        firstDarkColor = true;
                    } else if (!firstDarkColor) {
                        oppositeColorSetup = true;
                    }*/
                    break;
                default:
                    btnColorLight2.setBackground(newColor);
//                    btnColorDark2.setBackground(countDarkOppositeColor(newColor));
                    /*if (firstDarkColor == null || (!firstDarkColor && !oppositeColorSetup)) {
                        firstDarkColor = false;
                    } else if (!firstDarkColor) {
                        oppositeColorSetup = true;
                    }*/
                    break;
            }
        }
    }

    private Color countBrightOppositeColor(Color dark) {
        //0 - 255
        while (getBrightness(dark) > 125) {
            dark = getBrighterColor(dark);
        }
        int maxSteps = 10;
        int a = 0;
        Color tmpColor = dark;
        int brightness2 = getBrightness(tmpColor);
        int brightness = getBrightness(dark);
        int diff = 120;
        while (brightness2 - brightness < diff) {
            tmpColor = getBrighterColor(tmpColor);
            brightness2 = getBrightness(tmpColor);
            if (a == maxSteps || tmpColor.getRGB() == Color.WHITE.getRGB()) {
                dark = getDarkerColor(dark);
                brightness = getBrightness(dark);
                tmpColor = dark;
                brightness2 = getBrightness(tmpColor);
                a = 0;
                continue;
            }
            a++;
        }
        btnColorDark2.setBackground(dark);

//        System.out.println("Kontrast: " + (brightness - brightness2));
        return tmpColor;
    }

    private Color countDarkOppositeColor(Color light) {
        while (getBrightness(light) > 125) {
            light = getDarkerColor(light);
        }
        int maxSteps = 10;
        int a = 0;
        Color tmpColor = light;
        int brightness2 = getBrightness(tmpColor);
        int brightness = getBrightness(light);
        int diff = 120;
        while (brightness - brightness2 < diff) {
            tmpColor = getDarkerColor(tmpColor);
            brightness2 = getBrightness(tmpColor);
            if (a == maxSteps || tmpColor.getRGB() == Color.BLACK.getRGB()) {
                light = getBrighterColor(light);
                brightness = getBrightness(light);
                tmpColor = light;
                brightness2 = getBrightness(tmpColor);
                a = 0;
                continue;
            }
            a++;
        }
        btnColorLight2.setBackground(light);
//        System.out.println("Kontrast: " + (brightness - brightness2));
        return tmpColor;
    }

    private int getBrightness(Color c) {
        return (299 * c.getRed() + 587 * c.getGreen() + 114 * c.getBlue()) / 1000;
    }

    private Color getBrighterColor(Color c) {
        float count = 0.15f;
        int red = (int) Math.round(Math.min(255, c.getRed() + 255 * count));
        int green = (int) Math.round(Math.min(255, c.getGreen() + 255 * count));
        int blue = (int) Math.round(Math.min(255, c.getBlue() + 255 * count));
        return new Color(red, green, blue);
    }

    private Color getDarkerColor(Color c) {
        float count = 0.15f;
        int red = (int) Math.round(Math.max(255, c.getRed() -  255 * count));
        int green = (int) Math.round(Math.max(255, c.getGreen() - 255 * count));
        int blue = (int) Math.round(Math.max(255, c.getBlue() - 255 * count));
        return new Color(red, green, blue);
    }

    private Color getActualColor(int i ) {
        switch (i) {
            case 1: return btnColorDark.getBackground();
            case 2: return btnColorLight.getBackground();
            case 3: return btnColorDark2.getBackground();
            default: return btnColorLight2.getBackground();
        }
    }

    private void btnCallFileIn() {
        JFileChooser fileChooser = new JFileChooser();
        FileFilter imageFilter = new FileNameExtensionFilter(
                "Image files", ImageIO.getReaderFileSuffixes());
        fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
        fileChooser.setFileFilter(imageFilter);
        fileChooser.setCurrentDirectory(new java.io.File("."));
        fileChooser.setDialogTitle("Choose image");

        if (fileChooser.showOpenDialog(frame) == JFileChooser.APPROVE_OPTION) {
            File selectedFile = fileChooser.getSelectedFile();
            String path = selectedFile.getAbsolutePath();
            imgSource.setText(path);

            if (!destinationChanged) {
                int i = path.lastIndexOf("\\");
                if (i == -1) return;
                String tmp = path.substring(0, i);
                imgDest.setText(tmp + "\\new_qr.jpg");
            }
        }
    }

    private void btnCallFileOut() {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setCurrentDirectory(new java.io.File("."));
        fileChooser.setDialogTitle("Choose destination folder");
        fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fileChooser.setAcceptAllFileFilterUsed(false);

        if (fileChooser.showOpenDialog(frame) == JFileChooser.APPROVE_OPTION) {
            imgDest.setText(fileChooser.getCurrentDirectory().getAbsolutePath());
            destinationChanged = true;
        }
    }


}
