package com.company;

import com.company.PolynomialGenerator;
import java.util.ArrayList;
import java.util.HashMap;

public class Formula {
    public ArrayList<PolNumber> numbers;

    public Formula() {
        numbers = new ArrayList<PolNumber>();
    }

    public void addNumber(PolNumber n) {
        numbers.add(n);
    }

    public void addNumber(int i, PolNumber n) {
        numbers.add(i, n);
    }

    public void addNumber(int a, int x) {
        numbers.add(new PolNumber(a, x));
    }

    public int getSize() {
        return numbers.size();
    }

    public PolNumber getNumber(int i) {
        return numbers.get(i);
    }

    public void remove(int i) {
        numbers.remove(i);
    }

    public int[] getNumbers() {
        int[] ns = new int[getSize()];
        for (int i = 0; i < getSize(); i++) {
            ns[i] = getNumber(i).number;
        }
        return ns;
    }

    public void xorFormulas(Formula f2) {
       for (int i = 0; i < f2.getSize(); i++) {
           PolNumber n1 = null;
           PolNumber n2 = f2.getNumber(i);
           int n = 0;
           if (i >= getSize()) {
               n1 = new PolNumber();
               n1.number = n;
               numbers.add(n1);
           } else {
               n1 = getNumber(i);
               n = n1.number;
           }
           int xor = n ^ n2.number;
           n1.number = xor;
       }
    }

    public void convertToIntegerAnotation() {
        for (PolNumber number : numbers) {
            number.number = PolynomialGenerator.getNumberForExponent(number.a);
        }
    }

    public void convertToAlphaAnotation() {
        for (PolNumber number : numbers) {
            number.a = PolynomialGenerator.getExponentForNumber(number.number);
        }
    }

    public void increaseX(int by) {
        for (PolNumber number : numbers) {
            number.increaseX(by);
        }
    }

    public void increaseA(int by) {
        for (PolNumber number : numbers) {
            number.increaseA(by);
        }
    }

    public void decreaseA(int by) {
        for (PolNumber number : numbers) {
            number.decreaseA(by);
        }
    }

    public void decreaseX(int by) {
        for (PolNumber number : numbers) {
            number.decreaseX(by);
        }
    }

    public int getHighestX() {
        int max = 0;
        for (PolNumber number : numbers) {
            if (number.x > max) max = number.x;
        }
        return max;
    }

    public Formula clone() {
        Formula f = new Formula();
        for (PolNumber n : numbers) {
            f.addNumber(n.clone());
        }
        return f;
    }

    public void setNumbers(int x) {
        for (PolNumber n : numbers) {
            n.number = x;
        }
    }

    public PolNumber getPolNumberOfHighestX() {
        int max = 0;
        int id = 0;
        for (int i = 0; i < numbers.size(); i++) {
            PolNumber n = numbers.get(i);
            if (n.x > max) {
                max = n.x;
                id = i;
            }
        }
        return numbers.get(id);
    }

    public String toString() {
        String result = "";
        for (PolNumber number : numbers) {
            result += number.number + "a" + number.a + "x" + number.x + " + ";
        }
        return result;
    }

    public String printNumbers(HashMap table) {
        String result = "";
        for (PolNumber number : numbers) {
            result += (Integer) table.get(number.a) + ",";
        }
        return result;
    }
}
