package com.company;

import sun.awt.image.BufferedImageDevice;

import java.awt.*;
import java.awt.image.BufferedImage;

public final class ImageMaker {

    private Color dark;
    private Color light;
    private Color dark2;
    private Color light2;

    public static BufferedImage getImageFromArray(int[][] pixels) {
        BufferedImage bufferedImage = new BufferedImage(pixels.length * 10 + 80,
                pixels.length * 10 + 80,
                BufferedImage.TYPE_INT_RGB);
        for (int y = 0; y < bufferedImage.getWidth(); y++) {
            for (int x = 0; x < bufferedImage.getWidth(); x++) {
                bufferedImage.setRGB(x, y, Color.white.getRGB());
            }
        }

        for (int y = 0; y < pixels.length; y++) {
            for (int x = 0; x < pixels.length; x++) {
                Color c = getBlackWhite(pixels[y][x]);
                for (int yy = 0; yy < 10; yy++) {
                    for (int xx = 0; xx < 10; xx++) {
                        bufferedImage.setRGB(40 + x * 10 + xx, 40 + y * 10 + yy, c.getRGB());
                    }
                }
            }
        }
        return bufferedImage;
    }

    public static Color getBrighter(Color input) {
        int r1 = input.getRed();
        int g1 = input.getGreen();
        int b1 = input.getBlue();

        int r2 = 255 - r1;
        int g2 = 255 - g1;
        int b2 = 255 - b1;

        r2 *= 0.5;
        g2 *= 0.5;
        b2 *= 0.5;

        return new Color(r1 + r2, g1 + g2, b1 + b2);
    }

    public void setupColors(Color d, Color l, Color d2, Color l2) {
        dark = d;
        light = l;
        dark2 = d2;
        light2 = l2;
    }

    private int[][] scaleQR(int[][] qr, int density) {
        int[][] newQR = new int[qr.length * density][qr.length * density];
        int xq = 0;
        int yq = 0;
        int tmpY = 0;
        for (int y = 0; y < qr.length; y++, tmpY++) {
            int tmpX = 0;
            xq = 0;
            for (int x = 0; x < qr.length; x++, tmpX++) {
                int c = qr[y][x];
                for (int yy = 0; yy < density; yy++) {
                    for (int xx = 0; xx < density; xx++) {
                        newQR[y * density + yy][x * density + xx] = c;
/*                        if (tmpX == density - 1) {
                            tmpX = -1;
                            xq++;
                        }*/
                    }
                }
            }
            /*if (tmpY == density - 1) {
                tmpY = -1;
                yq++;
            }*/
        }
        return newQR;
    }

    public BufferedImage mergeQRLogo(int[][] qr, int[][] logo, int density, int size) {
        System.out.println("DARKCOLOR: \t" + dark2.getRGB());
        System.out.println("BRIGHTCOLOR: \t" + light2.getRGB());

        qr = scaleQR(qr, density);

        BufferedImage img = new BufferedImage(qr.length * size + 8 * size * density,
                qr.length * size + 8 * size * density,
                BufferedImage.TYPE_INT_RGB);
        int margin = 4 * size * density;

        for (int y = 0; y < img.getWidth(); y++) {
            for (int x = 0; x < img.getWidth(); x++) {
                img.setRGB(x, y, Color.white.getRGB());
            }
        }

        int xq = 0;
        int yq = 0;
        int tmpY = 0;
        for (int y = 0; y < logo.length; y++) {
            int tmpX = 0;
            xq = 0;
            for (int x = 0; x < logo.length; x++) {
                int c = qr[y][x];
                int l = logo[y][x];
                int finalColor;
                if (c == 1) {
                    if (c == l) finalColor = dark2.getRGB();
                    else finalColor = dark.getRGB();
                } else {
                    if (c == l)  finalColor = light.getRGB();
                    else finalColor = light2.getRGB();
                }
                /*if (c == 1) {
                    finalColor = dark.getRGB();
                } else {
                    finalColor = light.getRGB();
                }*/
                for (int yy = 0; yy < size; yy++) {
                    for (int xx = 0; xx < size; xx++) {
                        img.setRGB(margin + x * size + xx, margin + y * size + yy, finalColor);
                    }
                }
            }
        }
        return img;
    }

    public static Color getBlackWhite(int p) {
        return (p == 1) ? Color.BLACK : Color.white;
    }
}
