package com.company;


import java.util.Arrays;

public final class Masks {

    private static QRCodeClient client;

    public static void setClient(QRCodeClient c) {
        client = c;
    }

    public static int countPenaltyForMatrix(int[][] matrix) {
        int penalty = evaluationConditionOne(matrix);
        penalty += evaluationConditionTwo(matrix);
        penalty += evaluationConditionThree(matrix);
        penalty += evaluationConditionFour(matrix);
        return penalty;
    }

    // same color for 5 modules or more
    public static int evaluationConditionOne(int[][] matrix) {
        int[][] tmp = matrix.clone();
        int state = -1;
        int penalty = 0;
        int total = 0;
        for (int y = 0; y < tmp.length; y++) {
            for (int x = 0; x < tmp.length; x++) {
                int n = tmp[y][x];
                n = (n % 2 == 0) ? 0 : 1;
                if (n == state) {
                    if (total == 5) {
                        penalty += 3;
                        total++;
                    } else if(total > 5) {
                        penalty++;
                        total++;
                    } else {
                        total++;
                    }
                } else {
                    state = n;
                    total = 1;
                }
            }
        }

        for (int x = 0; x < tmp.length; x++) {
            for (int y = 0; y < tmp.length; y++) {
                int n = tmp[y][x];
                n = (n % 2 == 0) ? 0 : 1;
                if (n == state) {
                    if (total == 5 ) {
                        penalty += 3;
                        total++;
                    } else if(total > 5) {
                        penalty++;
                        total++;
                    } else {
                        total++;
                    }
                } else {
                    state = n;
                    total = 1;
                }
            }
        }
        System.out.println("penalty 1 \t" + penalty);
        return penalty;
    }

    public static int evaluationConditionTwo(int[][] matrix) {
        int penalty = 0;
        for (int y = 0; y < matrix.length - 1; y++) {
            for (int x = 0; x < matrix.length - 1; x++) {
                penalty += checkSquareFromPos(x, y, matrix);
            }
        }
        System.out.println("penalty 2 \t" + penalty);
        return penalty;
    }

    private static int checkSquareFromPos(int x, int y, int[][] matrix) {
        int n = matrix[y][x];
        n = (n % 2 == 0) ? 0 : 1;
        if ((matrix[y][x + 1] % 2 == 0 ? 0 : 1) == n
                && (matrix[y + 1][x] % 2 == 0 ? 0 : 1) == n
                && (matrix[y + 1][x + 1] % 2 == 0 ? 0 : 1) == n)
            return 3;
        return 0;
    }

    public static int evaluationConditionThree(int[][] matrix) {
        int penalty = 0;

        for (int y = 0; y < matrix.length; y++) {
            for (int x = 0; x < matrix.length - 10; x++) {
                penalty += checkPatternFromPosRight(x, y, matrix);
            }
        }

        for (int x = 0; x < matrix.length; x++) {
            for (int y = 0; y < matrix.length - 10; y++) {
                penalty += checkPatternFromPosDown(x, y, matrix);
            }
        }
//        penalty += checkPatternFromPosDown(x, y, matrix);

        System.out.println("penalty 3 \t" + penalty);
        return penalty;
    }

    public static int checkPatternFromPosRight(int x, int y, int[][] matrix) {
        int[][] tmp = matrix;
        if ((tmp[y][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 1] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 2] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 3] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 4] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 5] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 6] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 7] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 8] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 9] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 10] % 2 == 0 ? 0 : 1) == 1) return 40;
        if ((tmp[y][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 1] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 2] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 3] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 4] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 5] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 6] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y][x + 7] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 8] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 9] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y][x + 10] % 2 == 0 ? 0 : 1) == 0) return 40;
        return 0;
    }

    public static int checkPatternFromPosDown(int x, int y, int[][] matrix) {
        int[][] tmp = matrix.clone();
        if ((tmp[y][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 1][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 2][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 3][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 4][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 5][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 6][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 7][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 8][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 9][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 10][x] % 2 == 0 ? 0 : 1) == 1) return 40;
        if ((tmp[y][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 1][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 2][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 3][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 4][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 5][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 6][x] % 2 == 0 ? 0 : 1) == 1
                && (tmp[y + 7][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 8][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 9][x] % 2 == 0 ? 0 : 1) == 0
                && (tmp[y + 10][x] % 2 == 0 ? 0 : 1) == 0) return 40;
        return 0;
    }

    public static int evaluationConditionFour(int[][] matrix) {
        int width = matrix.length;
        int dark = countDarkModules(matrix);
        int perc = (int) ((double) dark / (double) (width * width) * 100);
        int previous =  Math.abs(getPreviousMultiple(perc) - 50) / 5;
        int next = Math.abs(getNextMultiple(perc) - 50) / 5;

        int total = (previous < next) ? previous * 10 : next * 10;
        System.out.println("penalty 4 \t" + total);
        return total;
    }

    private static int getPreviousMultiple(int number) {
        number--;
        while (number % 5 != 0) {
            number--;
        }
        return number;
    }

    private static int getNextMultiple(int number) {
        number++;
        while (number % 5 != 0) {
            number++;
        }
        return number;
    }

    public static int countDarkModules(int[][] matrix) {
        int[][] tmp = matrix.clone();
        int total = 0;

        for (int y = 0; y < matrix.length; y++) {
            for (int x = 0; x < matrix.length; x++) {
                if ((tmp[y][x] % 2 == 0 ? 0 : 1) == 1) total++;
            }
        }
        return total;
    }

    public static int[][] applyMaskForMatrix(int maskNumber, int[][] matrix) {
        switch (maskNumber) {
            case 0: return applyMaskNumberOne(matrix);
            case 1: return applyMaskNumberTwo(matrix);
            case 2: return applyMaskNumberThree(matrix);
            case 3: return applyMaskNumberFour(matrix);
            case 4: return applyMaskNumberFive(matrix);
            case 5: return applyMaskNumberSix(matrix);
            case 6: return applyMaskNumberSeven(matrix);
            case 7: return applyMaskNumberEight(matrix);
        }
        return null;
    }

    public static void addVersionToMask(int[][] matrix, int[] data) {
        int width = matrix.length;
        matrix[0][8] = data[14] + 6;
        matrix[1][8] = data[13] + 6;
        matrix[2][8] = data[12] + 6;
        matrix[3][8] = data[11] + 6;
        matrix[4][8] = data[10] + 6;
        matrix[5][8] = data[9] + 6;

        matrix[7][8] = data[8] + 6;
        matrix[8][8] = data[7] + 6;
        matrix[8][7] = data[6] + 6;

        matrix[8][5] = data[5] + 6;
        matrix[8][4] = data[4] + 6;
        matrix[8][3] = data[3] + 6;
        matrix[8][2] = data[2] + 6;
        matrix[8][1] = data[1] + 6;
        matrix[8][0] = data[0] + 6;

        matrix[8][width - 1] = data[14] + 6;
        matrix[8][width - 2] = data[13] + 6;
        matrix[8][width - 3] = data[12] + 6;
        matrix[8][width - 4] = data[11] + 6;
        matrix[8][width - 5] = data[10] + 6;
        matrix[8][width - 6] = data[9] + 6;
        matrix[8][width - 7] = data[8] + 6;
        matrix[8][width - 8] = data[7] + 6;

        matrix[width - 7][8] = data[6] + 6;
        matrix[width - 6][8] = data[5] + 6;
        matrix[width - 5][8] = data[4] + 6;
        matrix[width - 4][8] = data[3] + 6;
        matrix[width - 3][8] = data[2] + 6;
        matrix[width - 2][8] = data[1] + 6;
        matrix[width - 1][8] = data[0] + 6;
    }

    public static int[][] applyMaskNumberOne(int[][] matrix) {
        int width = matrix.length;
        int[][] matrix2 = new int[width][width];
        for (int y = 0; y < width; y++) {
            for (int x = 0; x < width; x++) {
                int n = matrix[y][x];
                if ((x + y) % 2 == 0 && n < 2) {
                    matrix2[y][x] = n ^ 1;
                } else {
                    matrix2[y][x] = n;
                }
            }
        }
        int[] version = client.getVersion().generateVersionData(0);
        addVersionToMask(matrix2, version);
        return matrix2;
    }

    public static int[][] applyMaskNumberTwo(int[][] matrix) {
        int width = matrix.length;
        int[][] matrix2 = new int[width][width];
        for (int y = 0; y < width; y++) {
            for (int x = 0; x < width; x++) {
                if (matrix[y][x] < 2) {
                    int n = matrix[y][x];
                    if (y % 2 == 0) {
                        matrix2[y][x] = (n == 0) ? 1 : 0;
                    } else {
                        matrix2[y][x] = n;
                    }
                } else {
                    matrix2[y][x] = matrix[y][x];
                }
            }
        }
        int[] version = client.getVersion().generateVersionData(1);
        addVersionToMask(matrix2, version);
        return matrix2;
    }

    public static int[][] applyMaskNumberThree(int[][] matrix) {
        int width = matrix.length;
        int[][] matrix2 = new int[matrix.length][matrix.length];
        for (int y = 0; y < width; y++) {
            for (int x = 0; x < width; x++) {
                if (matrix[y][x] < 2) {
                    int n = matrix[y][x];
                    if ((x) % 3 == 0) {
                        matrix2[y][x] = (n == 0) ? 1 : 0;
                    } else {
                        matrix2[y][x] = n;
                    }
                } else {
                    matrix2[y][x] = matrix[y][x];
                }
            }
        }
        int[] version = client.getVersion().generateVersionData(2);
        addVersionToMask(matrix2, version);
        return matrix2;
    }

    public static int[][] applyMaskNumberFour(int[][] matrix) {
        int width = matrix.length;
        int[][] matrix2 = new int[matrix.length][matrix.length];
        for (int y = 0; y < width; y++) {
            for (int x = 0; x < width; x++) {
                if (matrix[y][x] < 2) {
                    int n = matrix[y][x];
                    if ((y + x) % 3 == 0) {
                        matrix2[y][x] = (n == 0) ? 1 : 0;
                    } else {
                        matrix2[y][x] = n;
                    }
                } else {
                    matrix2[y][x] = matrix[y][x];
                }
            }
        }
        int[] version = client.getVersion().generateVersionData(3);
        addVersionToMask(matrix2, version);
        return matrix2;
    }

    public static int[][] applyMaskNumberFive(int[][] matrix) {
        int width = matrix.length;
        int[][] matrix2 = new int[matrix.length][matrix.length];
        for (int y = 0; y < width; y++) {
            for (int x = 0; x < width; x++) {
                if (matrix[y][x] < 2) {
                    int n = matrix[y][x];
                    if ((Math.floor((y / 2)) + Math.floor(( x / 3)))
                            % 2 == 0) {
                        matrix2[y][x] = (n == 0) ? 1 : 0;
                    } else {
                        matrix2[y][x] = n;
                    }

                } else {
                    matrix2[y][x] = matrix[y][x];
                }
            }
        }
        int[] version = client.getVersion().generateVersionData(4);
        addVersionToMask(matrix2, version);
        return matrix2;
    }

    public static int[][] applyMaskNumberSix(int[][] matrix) {
        int width = matrix.length;
        int[][] matrix2 = new int[matrix.length][matrix.length];
        for (int y = 0; y < width; y++) {
            for (int x = 0; x < width; x++) {
                if (matrix[y][x] < 2) {
                    int n = matrix[y][x];
                    if (((x * y) % 2) + ((x * y) % 3) == 0) {
                        matrix2[y][x] = (n == 0) ? 1 : 0;
                    } else {
                        matrix2[y][x] = n;
                    }
                } else {
                    matrix2[y][x] = matrix[y][x];
                }
            }
        }
        int[] version = client.getVersion().generateVersionData(5);
        addVersionToMask(matrix2, version);
        return matrix2;
    }

    public static int[][] applyMaskNumberSeven(int[][] matrix) {
        int width = matrix.length;
        int[][] matrix2 = new int[matrix.length][matrix.length];
        for (int y = 0; y < width; y++) {
            for (int x = 0; x < width; x++) {
                if (matrix[y][x] < 2) {
                    int n = matrix[y][x];
                    if ((((x * y) % 2) + ((x * y) % 3))
                            % 2 == 0) {
                        matrix2[y][x] = (n == 0) ? 1 : 0;
                    } else {
                        matrix2[y][x] = n;
                    }
                } else {
                    matrix2[y][x] = matrix[y][x];
                }
            }
        }
        int[] version = client.getVersion().generateVersionData(6);
        addVersionToMask(matrix2, version);
        return matrix2;
    }

    public static int[][] applyMaskNumberEight(int[][] matrix) {
        int width = matrix.length;
        int[][] matrix2 = new int[matrix.length][matrix.length];
        for (int y = 0; y < width; y++) {
            for (int x = 0; x < width; x++) {
                if (matrix[y][x] < 2) {
                    int n = matrix[y][x];
                    if ((((x + y) % 2) + ((x * y) % 3))
                            % 2 == 0) {
                        matrix2[y][x] = (n == 0) ? 1 : 0;
                    } else {
                        matrix2[y][x] = n;
                    }
                } else {
                    matrix2[y][x] = matrix[y][x];
                }
            }
        }
        int[] version = client.getVersion().generateVersionData(7);
        addVersionToMask(matrix2, version);
        return matrix2;
    }
}
