package com.company.QR;

import com.company.QRCodeClient;

import java.util.HashMap;

public class QRCodeMode {
    private QRCodeClient client;
    private byte NUMERIC = 0x01;
    private byte ALPHANUMERIC = 0x02;
    private byte BYTE = 0x04;
    private byte KANJI = 0x08;
    private byte ECI = 0x07;

    private byte mode;

    public QRCodeMode(QRCodeClient c) {
        client = c;
        mode = chooseMode(client.getMsg());
    }

    public int getBits() {
        return 0;
    }

    private byte chooseMode(String content) {
        HashMap table = client.getAlphaNumericTable();
        boolean numeric = false;
        boolean alphanumeric = false;
        for (int i = 0; i < content.length(); i++) {
            char c = content.charAt(i);
            if (c >= '0' && c <= '9') numeric = true;
            if (client.hasAlphaNumericTableChar(c)) alphanumeric = true;
        }

        if (alphanumeric) return ALPHANUMERIC;
        if (numeric) return NUMERIC;
        return BYTE;
    }

    public byte getMode() { return mode; }

    public String getByteMode() { return String.format("%4s", Integer.toBinaryString(client.getMode() & 0xFF)).replace(' ', '0'); }
}
